Rem Parallel.Bas   7/15/95 K8CG
Rem                rev 6/12/96 - startup/shutdown and .ini file
Rem                              entries

Rem Control rig up/down via parallel port bits
Rem Switch station at startup and shutdown

Option Explicit
Option Compare Text

Rem These variables are global so they can be changed by
Rem       setup!

Rem Bits to use for up/down
Global Tune_UpBit As Integer
Global Tune_DnBit As Integer

Global ParallelMask As Integer

Global ShutdownByte As Integer
Global SetupByte As Integer

Global ParallelPortAddress

Sub CloseParallelHdw ()
Rem Called at shutdown

If ParallelPortAddress = 0 Then Exit Sub

frmControl!IOPortParallel.OutputValue = ShutdownByte

End Sub

Sub InitializeParallelParams ()
Rem Called at startup to initialize the data values

ParallelPortAddress = GetIntegerPref("ParallelPort", "BaseAddress", "0")
SetupByte = GetIntegerPref("ParallelPort", "SetupByte", "0")
ShutdownByte = GetIntegerPref("ParallelPort", "ShutdownByte", "0")
Tune_UpBit = GetIntegerPref("ParallelPort", "Tune_upbit", "1")
Tune_DnBit = GetIntegerPref("ParallelPort", "Tune_dnbit", "2")

ParallelMask = Tune_UpBit Or Tune_DnBit

End Sub

Sub InitParallelHdw ()
Rem Called at startup

If ParallelPortAddress = 0 Then Exit Sub

frmControl!IOPortParallel.IOPortAddress = ParallelPortAddress
frmControl!IOPortParallel.OutputValue = SetupByte

End Sub

Sub ParallelTune (UpDown As String)
Dim Counter As Long, directionbits As Integer

If ParallelPortAddress = 0 Then Exit Sub

Select Case UpDown
    Case "up"
        directionbits = Tune_UpBit
    Case "down"
        directionbits = Tune_DnBit
    Case Else
        directionbits = 0
End Select

Rem Toggle the proper bit (pulse on)
    frmControl!IOPortParallel.OutputValue = directionbits Xor SetupByte

Rem PULSE WIDTH
Rem Delay on my machine, 1-> 1msec pulses, 1000->4msec
    For Counter = 0 To DelayCount * DelayMsec / 4
    Next Counter
Rem Restore the bit (pulse off)
    frmControl!IOPortParallel.OutputValue = SetupByte
Rem PULSE INTERVAL
    For Counter = 0 To DelayCount * DelayMsec / 4
    Next Counter

End Sub

